//
// PLBot - OLO's bot
//
// (http://www.olo.counter-strike.pl/)
//
// bot_client.cpp
//
/*
 * Copyright (c) 2004 OLO
 * This file is a part of PLBot application.
 * You are not allowed to remove these copyrights.
 */

#include <extdll.h>
#include <sdk_util.h>
#include <cbase.h>
#include <player.h>

#include <dllapi.h>
#include <meta_api.h>
#include <sdk_util.h>

#include "bot.h"
#include "plbot_api.h"  // me


// types of damage to ignore...
#define IGNORE_DAMAGE (DMG_FALL | DMG_CRUSH | DMG_FREEZE | DMG_SHOCK | DMG_DROWN | DMG_NERVEGAS | DMG_RADIATION | DMG_DROWNRECOVER | DMG_ACID | DMG_SLOWBURN | DMG_SLOWFREEZE)

bot_weapon_t weapon_defs[MAX_WEAPONS]; // array of weapon definitions

//extern int message_state;
bool not_found_goal = TRUE;
bool RoundGoing = FALSE;
float grenade_time = 0.0;

extern int message_state;

// This message is sent when a menu is being displayed in Counter-Strike.
void BotClient_VGUIMenu(void *p, player_t *pBot)
{
   if (message_state == 0)
   {
      if ((*(int *)p) == 2)  // is it a team select menu?
         pBot->start_action = MSG_CS_TEAM_SELECT;
      else if ((*(int *)p) == 26)  // is is a terrorist model select menu?
         pBot->start_action = MSG_CS_T_SELECT;
      else if ((*(int *)p) == 27)  // is is a counter-terrorist model select menu?
         pBot->start_action = MSG_CS_CT_SELECT;
   }

   message_state++;

   if (message_state == 5)  // ignore other fields in VGUI message
      message_state = 0;
}

// This message is sent when a client joins the game.
void BotClient_WeaponList(void *p, player_t *pBot)
{
   static bot_weapon_t bot_weapon;

   switch (message_state)
   {
   case 0:
      message_state++;
      strcpy(bot_weapon.szClassname, (char *)p);
      break;
   case 1:
      message_state++;
      bot_weapon.iAmmo = *(int *)p;
      break; // ammo index 1
   case 2:
      message_state++;
      bot_weapon.iAmmoMax = *(int *)p;
      break; // max ammo1
   case 3:
      message_state++;
      break;
   case 4:
      message_state++;
      break;
   case 5:
      message_state++;
      bot_weapon.iSlot = *(int *)p;
      break; // slot for this weapon
   case 6:
      message_state++;
      bot_weapon.iPosition = *(int *)p;
      break;  // position in slot

   case 7:
      message_state++;
      bot_weapon.iId = *(int *)p;
      break;  // weapon ID
   case 8:
      message_state = 0;

      bot_weapon.iFlags = *(int *)p;  // flags for weapon (WTF???)
      // store away this weapon with it's ammo information...
      weapon_defs[bot_weapon.iId] = bot_weapon;
      break;
   }
}

// This message gets sent when the bot picks up an item
void BotClient_SetFOV(void *p, player_t *pBot)
{
   pBot->zoom_fov = *(int *)p;//Save bot's fov
}

// This message is sent when a weapon is selected (either by the bot chosing
// a weapon or by the server auto assigning the bot a weapon).
void BotClient_CurrentWeapon(void *p, player_t *pBot)
{
   static int iState;
   static int iId;
   static int iClip;

   if (message_state == 0)
   {
      message_state++;
      iState = *(int *)p;  // state of the current weapon
   }
   else if (message_state == 1)
   {
      message_state++;
      iId = *(int *)p;  // weapon ID of current weapon
   }
   else if (message_state == 2)
   {
      message_state = 0;

      iClip = *(int *)p;  // ammo currently in the clip for this weapon

      if ((iState == 1) && (iId < 31))
      {
         pBot->current_weapon.iId = iId;
         pBot->current_weapon.iClip = iClip;
         pBot->m_rgAmmo[weapon_defs[iId].iClip] = iClip;

         // update the ammo counts for this weapon...
         pBot->current_weapon.iAmmo = pBot->m_rgAmmo[weapon_defs[iId].iAmmo];
      }
   }
}

// This message is sent whenever ammo ammounts are adjusted (up or down).
void BotClient_AmmoX(void *p, player_t *pBot)
{
   static int index;
   static int ammount;
   int ammo_index;

   if (message_state == 0)
   {
      message_state++;
      index = *(int *)p;  // ammo index (for type of ammo)
   }
   else if (message_state == 1)
   {
      message_state = 0;
      ammount = *(int *)p;  // the ammount of ammo currently available
      pBot->m_rgAmmo[index] = ammount;  // store it away
      ammo_index = pBot->current_weapon.iId;

      // update the ammo counts for this weapon...
      pBot->current_weapon.iAmmo = pBot->m_rgAmmo[weapon_defs[ammo_index].iAmmo];
   }
}

// This message is sent when the bot picks up some ammo
void BotClient_AmmoPickup(void *p, player_t *pBot)
{
   static int index;
   static int ammount;
   int ammo_index;

   if (message_state == 0)
   {
      message_state++;
      index = *(int *)p;
   }
   else if (message_state == 1)
   {
      message_state = 0;
      ammount = *(int *)p;
      pBot->m_rgAmmo[index] = ammount;
      ammo_index = pBot->current_weapon.iId;

      // update the ammo counts for this weapon...
      pBot->current_weapon.iAmmo = pBot->m_rgAmmo[weapon_defs[ammo_index].iAmmo];
   }
}

void BotClient_HLTV(void *p, player_t *pBot)
{
   if (message_state == 0)
   {
      if ((*(int *)p) == 0)
      {
         for (int i = 1; i <= gpGlobals->maxClients; i++)
         {
            pBot = GET_IPLAYERPOINTER(i);
            if (!IsValidPlayer(pBot) || !(pBot->pEdict->v.flags & FL_FAKECLIENT))
               continue;
            pBot->buy_state = 0;
            BotSpawnInit( pBot, RESPAWN_START_ROUND);
         }
         RoundGoing = TRUE; //Start this round
      }
   }
   message_state++;
}

void BotClient_TextMsg(void *p, player_t *pBot)
{
   if (message_state == 1)
   {
      char *msg = (char *)p;

      if (FStrEq(msg, "#Bomb_Planted"))
      {
         for (int index = 1; index < 33; index++)
            if (IsValidPlayer(&bots[index]))
            {
               bots[index].planedGoal = NULL;
               bots[index].user_action &= ~USER_HOLD; //Remove hold this position flag
            }

         bombnotfound = TRUE;
         bombplanted = TRUE;
         bombplaced = NULL;
         bomb_check_time = gpGlobals->time + 0.2; //Check for bomb with delay
      }
      else if (FStrEq(msg, "#Game_bomb_drop"))
      {
         //Go through bots and reset their arrays
         for (int index = 1; index < 33; index++)
            if (IsValidPlayer(&bots[index]))
               bots[index].planedGoal = NULL;

         bombnotfound = TRUE;
         bombdroped = TRUE;
         bombplaced = NULL;
         bomb_check_time = gpGlobals->time + 0.2; //Check for bomb with delay
      }
      else if (FStrEq(msg, "#Got_bomb"))
      {
         //Go through bots and reset their arrays
         for (int index = 1; index < 33; index++)
            if (IsValidPlayer(&bots[index]))
               bots[index].planedGoal = NULL;

         bombnotfound = FALSE;
         bombdroped = FALSE;
         bombplanted = FALSE;
         bombplaced = NULL;
         pBot->havebomb = TRUE;
      }
   }
   message_state++;
}

// This message gets sent when the bot picks up a weapon.
void BotClient_WeaponPickup(void *p, player_t *pBot)
{
   if (*(int *)p == CS_WEAPON_C4)
   {
      pBot->havebomb = TRUE;
      bombdroped = FALSE;
      bombplanted = FALSE;
      bombnotfound = FALSE;
   }
}

// This message gets sent when the bots are getting damaged.
void BotClient_Damage(void *p, player_t *pBot)
{
   static int damage_armor;
   static int damage_taken;
   static int damage_bits;  // type of damage being done
   static Vector damage_origin;

   switch (message_state)
   {
   case 0:
      message_state++;
      damage_armor = *(int *)p;
      break;
   case 1:
      message_state++;
      damage_taken = *(int *)p;
      break;
   case 2:
      message_state++;
      damage_bits = *(int *)p;
      break;
   case 3:
      message_state++;
      damage_origin.x = *(float *)p;
      break;
   case 4:
      message_state++;
      damage_origin.y = *(float *)p;
      break;
   case 5:
      message_state = 0;

      damage_origin.z = *(float *)p;

      if ((damage_armor > 0) || (damage_taken > 0))
      {
         // ignore certain types of damage...
         if (damage_bits & IGNORE_DAMAGE)
            return;

         edict_t *pEnt = pBot->pEdict->v.dmg_inflictor;

         if (Chance(3) && (!pBot->pBotEnemy))
         {
            if (FClassnameIs(pEnt,"player") && !FromYourTeam(pBot, &bots[ENTINDEX(pEnt)]))
            {
               pBot->pBotEnemy = pEnt;
               pBot->say_radio |= RADIO_TAKINGFIRE;
               pBot->shoot_time = gpGlobals->time + 0.2;
            }
         }
      }

      break;
   }
}

// This message gets sent when the bots money ammount changes (for CS)
void BotClient_Money(void *p, player_t *pBot)
{
   if (message_state == 0)
   {
      message_state++;
      pBot->bot_money = *(int *)p;  // amount of money
   }
   else
      message_state = 0;  // ingore this field
}

// This message gets sent when the bots get killed
void BotClient_DeathMsg(void *p, player_t *pBot)
{
   static int killer_index;
   static int victim_index;

   if (message_state == 0)
   {
      message_state++;
      killer_index = *(int *)p;  // ENTINDEX() of killer
   }
   else if (message_state == 1)
   {
      message_state++;
      victim_index = *(int *)p;  // ENTINDEX() of victim
   }
   else if (message_state == 2)
   {
      message_state++;
      edict_t *victim_edict = NULL;
      if (victim_index != 0)
         victim_edict = INDEXENT(victim_index); //Get victim edict

      // store edict of player that killed this bot...
      edict_t *killer_edict = NULL;
      if (killer_index != 0)
         killer_edict = INDEXENT(killer_index); //Get killer edict

      if (Maptype == CS_MAP)
         FreeMyHostage(victim_edict); //Free hostages of this player

      for (int i = 1; i <= gpGlobals->maxClients; i++)
      {
         player_t *pSlayer = GET_IPLAYERPOINTER(i);

         if (IsValidPlayer(pSlayer) && (pSlayer->pHelpme == victim_edict))
         {
            pSlayer->user_action &= ~USER_GOGOGO;
            pSlayer->user_action &= ~USER_FOLLOWME;
            pSlayer->pHelpme = NULL;
         }
      }
   }
   else if (message_state == 3)
      message_state = 0;
}

// This message gets sent when the bots screen is blinked
void BotClient_ScreenFade(void *p, player_t *pBot)
{
   static int duration;
   static int hold_time;
   static int fade_flags;
   int length;

   if (message_state == 0)
   {
      message_state++;
      duration = *(int *)p;
   }
   else if (message_state == 1)
   {
      message_state++;
      hold_time = *(int *)p;
   }
   else if (message_state == 2)
   {
      message_state++;
      fade_flags = *(int *)p;
   }
   else if (message_state == 6)
   {
      message_state = 0;
      length = (duration + hold_time) / 4096;
      pBot->blinded_time = gpGlobals->time + length - 2.0;
   }
   else
   {
      message_state++;
   }
}

// This message gets sent when the Icon status changes
void BotClient_Icon(void *p, player_t *pBot)
{
   static int icon;

   if (message_state == 0)
   {
      //0 hide icon; 1 show icon; 2 blinking icon
      icon = (*(int *)p);
      message_state++;
   }
   else if (message_state == 1)
   {
      if (FStrEq((char *)p, "buyzone"))
      {
         switch (icon)
         {
         case 0: //icon not visible
            pBot->inbuyzone = FALSE;
            break;
         case 1: //Visible
            pBot->inbuyzone = TRUE;
            break;
         }
      }
      else if (FStrEq((char *)p, "c4"))
      {
         switch (icon)
         {
         case 0: //C4 icon not visible
            pBot->havebomb = FALSE;
            pBot->inbombzone = FALSE;
            break;
         case 1: //Visible but not active
            pBot->havebomb = TRUE;
            pBot->inbombzone = FALSE;
            break;
         case 2: //Active icon - blinking
            pBot->havebomb = TRUE;
            pBot->inbombzone = TRUE;
            break;
         }
      }
   }
}

int DoYouCallMe(player_t *pBot, edict_t *pPlayer)
{
   TraceResult trEnd;
   Vector v_forward, v_right;
   ANGLEVECTORS( pPlayer->v.v_angle, v_forward, v_right, NULL );

   Vector vecSrc = GetGunPosition(pPlayer);

   UTIL_TraceLine( vecSrc, vecSrc + v_forward*4800, dont_ignore_monsters,
                   dont_ignore_glass, pPlayer->v.pContainingEntity, &trEnd); //Get aiming end pos

   if (FClassnameIs(trEnd.pHit , "player"))
   {
      if (trEnd.pHit == pBot->pEdict)
         return 1; //Yes you call him
      else
         return -1; //No but someone you have specifed
   }

   return 0; //No you don't call anyone....
}


void ForbidOtherToListen()
{//Make other bots not listening radio is bots is specifed..
   for (int index = 1; index < 33; index++)
      bots[index].can_listen = FALSE;
}

//This is radio on which bots reacts
void BotClient_SendAudio(void *p, player_t *pBot)
{
   static player_t *pPlayer;
   int result;

   if (message_state == 0)
   {
      pPlayer = GET_IPLAYERPOINTER(*(int *)p); //Which player called bot
      message_state++; //Function progres...
      return;
   }
   //else if (FStrEq((char *)p, "%!MRAD_FIREINHOLE")) //This is for check greade to active ability for seraching greandes
   //{
   // grenade_time = gpGlobals->time + 0.5; //Check for world grenades in this time....
   //}
   else if ((pBot->can_listen) && (pBot != pPlayer) && (FromYourTeam(pBot, pPlayer))) //Don't check yourself and not allied also check if can hear...
   {
      float distance = (pPlayer->pEdict->v.origin - pBot->pEdict->v.origin).Length(); //Get distance

      if (FStrEq((char *)p, "%!MRAD_BACKUP")) //Need Backup!!!
      {
         //If you see player, help him!!!
         if (FVisible( pPlayer->pEdict->v.origin, pBot->pEdict ) && (distance < 1500))
         {
            pBot->action_time = gpGlobals->time;
            pBot->user_action = USER_FOLLOWME;
            pBot->user_action |= USER_COVERME;
            pBot->pHelpme = pPlayer->pEdict;
            pBot->say_radio |= RADIO_AFFIRMATIVE;
            pBot->bot_action = BOT_NOACTION;
         }
      }
      else if (FStrEq((char *)p, "%!MRAD_HITASSIST")) //Hit, need assistance
      {
         //If you don't have user, help him!!!
         if ((pBot->pHelpme == NULL) && FVisible( pPlayer->pEdict->v.origin, pBot->pEdict ) &&
               (distance < 1500))
         {
            pBot->pHelpme = pPlayer->pEdict;
            pBot->user_action = USER_FOLLOWME;
            pBot->say_radio |= RADIO_AFFIRMATIVE;
            pBot->bot_action = BOT_NOACTION;
         }
      }
      else if ((FStrEq((char *)p, "%!MRAD_FOLLOWME")) && (pBot->pHelpme == pPlayer->pEdict)) //Follow me
         //React if alrady is used by this user...
      {
         result = DoYouCallMe(pBot, pPlayer->pEdict);

         if (result == 1) //Yes he is talking to you!!!!
         {
            ForbidOtherToListen();
         } else if (result == -1) //To someone else...
         {
            message_state = 0;
            return;
         }

         pBot->say_radio |= RADIO_AFFIRMATIVE;
         pBot->bot_action = BOT_NOACTION;
         pBot->user_action = USER_FOLLOWME;
      } else if (FStrEq((char *)p, "%!MRAD_FOLLOWME")) //Follow me
      {
         //Follow man if he have free user slots....
         if ((distance < 1500) && (pPlayer->botcontrol < plb_control->value) &&
               FVisible( pPlayer->pEdict->v.origin, pBot->pEdict )
               && (distance < 1500))
         {
            result = DoYouCallMe(pBot, pPlayer->pEdict);

            if (result == 1) //Yes he is talking to you!!!!
            {
               ForbidOtherToListen();
            } else if (result == -1)  //To someone else...
            {
               message_state = 0;
               return;
            }

            pBot->user_action = USER_FOLLOWME;
            pBot->pHelpme = pPlayer->pEdict;
            pBot->say_radio |= RADIO_AFFIRMATIVE;
            pBot->bot_action = BOT_NOACTION;
            pPlayer->botcontrol++;
         }
      }
      else if (FStrEq((char *)p, "%!MRAD_REGROUP")) //Regroup team!!!
      {
         //Regroup whole team...
         if (pBot->pHelpme == pPlayer->pEdict)
         {
            pBot->action_time = gpGlobals->time;
            pBot->user_action = USER_NOACTION;
            pBot->pHelpme = NULL;
            pBot->say_radio |= RADIO_AFFIRMATIVE;
            pBot->bot_action = BOT_NOACTION;
            pPlayer->botcontrol = 0;
         }
      }
      else if (FStrEq((char *)p, "%!MRAD_TAKEPOINT")) //You take the point!!!
      {
         //If alrady have user take the position...
         if (pBot->pHelpme == pPlayer->pEdict)
         {
            result = DoYouCallMe(pBot, pPlayer->pEdict);

            if (result == 1) //Yes he is talking to you!!!!
            {
               ForbidOtherToListen();
               pPlayer->botcontrol--;
            } else if (result == -1)  //To someone else...
            {
               message_state = 0;
               return;
            } else //Not specified so to all bots...
               pPlayer->botcontrol = 0;

            pBot->action_time = gpGlobals->time + 128;
            pBot->user_action = USER_NOACTION;
            pBot->say_radio = RADIO_ONPOSITION;
            pBot->pHelpme = NULL;
            pBot->bot_action = BOT_DUCKING;
            pBot->bot_action |= BOT_STOPED;
         }
      }
      else if (FStrEq((char *)p, "%!MRAD_GETINPOS")) //Get in position!!!
      {
         //Get in position if alrady have this user
         if (pBot->pHelpme == pPlayer->pEdict)
         {
            result = DoYouCallMe(pBot, pPlayer->pEdict);

            if (result == 1) //Yes he is talking to you!!!!
            {
               ForbidOtherToListen();
            } else if (result == -1)  //To someone else...
            {
               message_state = 0;
               return;
            }

            pBot->action_time = gpGlobals->time + 128;
            pBot->user_action = USER_NOACTION;
            pBot->say_radio = RADIO_ONPOSITION;
            pBot->bot_action = BOT_DUCKING;
            pBot->bot_action |= BOT_STOPED;
         }
      }
      else if (FStrEq((char *)p, "%!MRAD_FALLBACK")) //Fall back team!!!
      {
         //User command to his follower
         if (pBot->pHelpme == pPlayer->pEdict)
         {
            result = DoYouCallMe(pBot, pPlayer->pEdict);

            if (result == 1) //Yes he is talking to you!!!!
            {
               ForbidOtherToListen();
            } else if (result == -1)  //To someone else...
            {
               message_state = 0;
               return;
            }

            pBot->avoid_angle = -pPlayer->pEdict->v.v_angle;
            pBot->avoid_time = gpGlobals->time + 1;
            pBot->user_gogogo_time = gpGlobals->time + 3;
            pBot->user_action = USER_GOGOGO;
            pBot->user_action |= USER_FALLBACK;
            pBot->bot_action = BOT_NOACTION;
         }
      }
      else if (FStrEq((char *)p, "%!MRAD_STORMFRONT")) //Storm the front!!!
      {
         //Storm command to all bots!!!
         if (pBot->pHelpme == pPlayer->pEdict)
         {
            pBot->avoid_angle = pPlayer->pEdict->v.v_angle;
            pBot->avoid_time = gpGlobals->time + 2;
            pBot->pHelpme = NULL;
            pBot->bot_action = BOT_NOACTION;
            pBot->user_action = USER_NOACTION;

            pPlayer->botcontrol = 0;
         }
      }
      else if (FStrEq((char *)p, "%!MRAD_GO")) //Go Go Go!!!
      {
         //Go Go Go to follower
         if (pBot->pHelpme == pPlayer->pEdict)
         {
            result = DoYouCallMe(pBot, pPlayer->pEdict);

            if (result == 1) //Yes he is talking to you!!!!
            {
               ForbidOtherToListen();
            } else if (result == -1) //To someone else...
            {
               message_state = 0;
               return;
            }

            pBot->avoid_angle = pPlayer->pEdict->v.v_angle;
            pBot->avoid_time = gpGlobals->time + 1;
            pBot->user_gogogo_time = gpGlobals->time + 3;
            pBot->user_action = USER_GOGOGO;
            pBot->bot_action = BOT_NOACTION;
         }
      }
      else if ((FStrEq((char *)p, "%!MRAD_COVERME")) && (pBot->pHelpme == pPlayer->pEdict))//Cover me!!!
         //Only for followers
      {
         result = DoYouCallMe(pBot, pPlayer->pEdict);

         if (result == 1) //Yes he is talking to you!!!!
         {
            ForbidOtherToListen();
         } else if (result == -1) //To someone else...
         {
            message_state = 0;
            return;
         }

         pBot->say_radio |= RADIO_AFFIRMATIVE;
         pBot->user_action = USER_FOLLOWME;
         pBot->user_action |= USER_COVERME;
         pBot->bot_action = BOT_NOACTION;
      } else if (FStrEq((char *)p, "%!MRAD_COVERME")) //Cover me!!!
      {
         //User calls new bots for covering him...
         if (((pBot->say_radio & RADIO_COVERME) == FALSE) && (pBot->pHelpme == NULL) &&
               (pPlayer->botcontrol < plb_control->value)  && (distance < 1500) &&
               FVisible( pPlayer->pEdict->v.origin, pBot->pEdict ) && (distance < 1500))
         {
            result = DoYouCallMe(pBot, pPlayer->pEdict);

            if (result == 1) //Yes he is talking to you!!!!
            {
               ForbidOtherToListen();
            } else if (result == -1) //To someone else...
            {
               message_state = 0;
               return;
            }

            pBot->bot_action = BOT_NOACTION;
            pBot->say_radio &= ~RADIO_ONPOSITION;
            pBot->pHelpme = pPlayer->pEdict;
            pBot->say_radio |= RADIO_AFFIRMATIVE;
            pBot->user_action = USER_FOLLOWME;
            pBot->user_action |= USER_COVERME;
            pPlayer->botcontrol++;
         }
      }
      else if (FStrEq((char *)p, "%!MRAD_STICKTOG")) //Stick together!!!
      {
         //Only for visible followers...
         if ((pBot->pHelpme == pPlayer->pEdict) && (FVisible( pPlayer->pEdict->v.origin, pBot->pEdict )))
         {
            pBot->user_action |= USER_STICK;
            pBot->say_radio |= RADIO_AFFIRMATIVE;
         }

      }
      else if (FStrEq((char *)p, "%!MRAD_POSITION")) //Get in position
      {
         //To followers
         if (pBot->pHelpme == pPlayer->pEdict)
         {
            result = DoYouCallMe(pBot, pPlayer->pEdict);

            if (result == 1) //Yes he is talking to you!!!!
            {
               ForbidOtherToListen();
               pPlayer->botcontrol--;
            } else if (result == -1) //To someone else...
            {
               message_state = 0;
               return;
            } else //Not specified so to all bots...
               pPlayer->botcontrol = 0;

            pBot->user_action = USER_HOLD;
            pBot->vecHoldPosition = pPlayer->pEdict->v.origin;
            pBot->say_radio |= RADIO_AFFIRMATIVE;
            pBot->pHelpme = NULL;
            pBot->bot_action = BOT_DUCKING;
            pBot->bot_action |= BOT_STOPED;
            pBot->action_time = gpGlobals->time + 256;
         }
      }
   }

   pPlayer->can_listen = TRUE; //Remove restriction

   //Set bot say time
   pBot->say_time = gpGlobals->time + RANDOM_FLOAT(0.5, 1.5);

   message_state = 0;
}

